using System;
using System.Collections.Generic;
using System.Text;

namespace YAPS
{
    #region Data Structures
    /// <summary>
    /// holds all the data of one particular recording
    /// </summary>
    [Serializable]
    public class Recording
    {
        public String Recording_Name;
        public String Recording_Filename;
        public String Channel;
        public DateTime StartsAt;
        public DateTime EndsAt;
        public Guid Recording_ID;
        public bool CurrentlyRecording;

        public Recording()
        {
            Recording_ID = Guid.NewGuid();
            CurrentlyRecording = false;
        }
        // those would be nice to have in the future...
        // TODO: implement PlayCount and LastTimePlayed to have some detailed information handy for the WebGUI

        //public Int32 PlayCount;
        //public DateTime LastTimePlayed;

        // add options here :-)
    }
    #endregion
}
